using Dashboard.ImmediateDraw;
using Dashboard.Media;
using Dashboard.Typography;
using OpenTK.Mathematics;

namespace Dashboard.Controls
{
    public class Label : Control
    {
        public string Text { get; set; } = string.Empty;
        public Font? Font { get; set; }
        public float TextSize { get; set; }
        public bool AutoSize { get; set; } = true;

        protected override void ValidateLayout()
        {
            if (AutoSize)
            {
                Vector2 size = Typesetter.MeasureHorizontal(Text, TextSize, Font!);
                Size = size;
            }
        }

        protected override void ValidateVisual(DrawList cmd)
        {
            float padding = Padding;
            Vector2 origin = new Vector2(padding, padding);

            cmd.TypesetHorizontalDirect(Text, origin, TextSize, Font!);
        }
    }
}